
/*

  Read a pair of data files, forming cross-product bilinears.

*/

#include <stdio.h>
#include "datahdr.h"
#include "strmhdr.h"

static char *usage        = "USAGE: bilins <state> <file1> <file2>\n" ;

extern void sums () ;

void get_params (state, file1, file2, argc, argv)
char **state, **file1, **file2 ;
int argc ;
char *argv [] ;
{
  if (argc != 4)
  {
    fprintf (stderr, usage) ;
    exit (1) ;
  }
  *state = argv [1] ;

  if (! strcmp (argv [2], "-"))
    *file1 = NULL ;
  else
    *file1 = argv [2] ;

  if (! strcmp (argv [2], argv [3]))
    *file2 = *file1 ;
  else
  {
    if (! strcmp (argv [3], "-"))
      *file2 = NULL ;
    else
      *file2 = argv [3] ;
  }
}

void main (argc, argv)
int argc ;
char *argv [] ;
{
  char *state, *file1, *file2 ;
  DATA *datas, *data1, *data2 ;
  int   paramss [NUM_STT_PARAMS] ;
  int   params1 [NUM_DAT_PARAMS], params2 [NUM_DAT_PARAMS] ;
  float coeffss [NUM_STT_COEFFS] ;
  float coeffs1 [NUM_DAT_COEFFS], coeffs2 [NUM_DAT_COEFFS] ;
  int l_time, l_space ;

  get_params  (&state, &file1, &file2, argc, argv) ;

  datas = data_open_read (state) ;
  read_header (datas) ;
  read_coeffs (datas, coeffss) ;
  read_params (datas, paramss) ;
  data_close  (datas) ;

  data1 = data_open_read (file1) ;
  read_header (data1) ;
  read_coeffs (data1, coeffs1) ;
  read_params (data1, params1) ;

  if (file1 != file2)  /* Is this a cludge, or what? */
  {
    data2 = data_open_read (file2) ;
    read_header (data2) ;
    read_coeffs (data2, coeffs2) ;
    read_params (data2, params2) ;
  }
  else
  {
    int i ;

    data2 = data1 ;
    for (i = 0; i < NUM_DAT_COEFFS; i++)
      coeffs2 [i] = coeffs1 [i] ;
    for (i = 0; i < NUM_DAT_PARAMS; i++)
      params2 [i] = params1 [i] ;
  }

  fprintf (stdout, "%d\n", paramss [STT_L_T   ]) ;
  fprintf (stdout, "%d\n", params1 [DAT_SC    ]) ;
  fprintf (stdout, "%f\n", coeffs1 [DAT_K_FERM]) ;
  fprintf (stdout, "%d\n", params2 [DAT_SC    ]) ;
  fprintf (stdout, "%f\n", coeffs2 [DAT_K_FERM]) ;
  fprintf (stdout, "\n") ;

  l_time  = paramss [STT_L_T] ;
  l_space = paramss [STT_L_X] * paramss [STT_L_Y] * paramss [STT_L_Z] ;

  read_field_begin (data1) ;
  if (data1 != data2)
    read_field_begin (data2) ;
  sums (data1, data2, l_time, l_space) ;

  data_close (data1) ;
  if (data1 != data2)
    data_close (data2) ;
}

